// score:100
#include <bits/stdc++.h>

using namespace std;

#define int long long

int max(int a, int b, int c){
	return max(a, max(b, c));
}

int min(int a, int b, int c){
	return min(a, min(b, c));
}

int diff(int a, int b, int c){
	return max(a,b,c) - min(a,b,c);
}

int solve3(vector<int> &delic, int N, int sum){
    int K = 3;

    int a = -1;
    int S1 = 0;

    while(S1*K < sum){
        a++;
        S1 += delic[a];
    }

    //case1

    int S2 = 0;
    int S3 = sum - S2 - S1;

    int sol = diff(S1, S2, S3);

    for(int b=a+1; b<N; b++){
        S2 += delic[b];
        S3 -= delic[b];

        sol = min(sol, diff(S1, S2, S3));
    }

    //case2

    S1 -= delic[a];

    S2 = 0;
    S3 = sum - S2 - S1;

    sol = min(sol, diff(S1, S2, S3));

    for(int b=a; b<N; b++){
        S2 += delic[b];
        S3 -= delic[b];

        sol = min(sol, diff(S1, S2, S3));
    }

    return sol;
}

signed main() {
    
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int N, K; cin >> N >> K;

    vector<int> delic(N, 0);

    int sum = 0;

    for(int i=0; i<N; i++){
    	int in; cin >> in;
    	delic[i] += in;
    	sum += in;
    }
    /*
    for(int i=0; i<N; i++){
    	int in; cin >> in;
    	delic[i] += in;
    	sum += in;
    }*/
    
    
    if(N == 0){
    	cout << 0 << "\n";
    	return 0;
    }


    //int C = (sum+K) / (K+1);
    K++; //add Stofl

    int a = -1;
    int S1 = 0;

    while(S1*K < sum){
    	a++;
    	S1 += delic[a];
    }

    if(K == 2){
    	int S2 = sum - S1;
    	cout << min( abs(S2 - S1), abs(S2 + delic[a] - (S1-delic[a]))) << "\n";

    	return 0;
    }


    int sol = solve3(delic, N, sum);

    reverse(delic.begin(), delic.end());

    sol = min(sol, solve3(delic, N, sum));


    cout << sol << "\n";
}